package edu.uci.eecs.specCompiler.specExtraction;

import java.util.ArrayList;

public class ActionSubConstruct {
	public static class DefineVar {
		public final String varType;
		public final String varName;
		public final String varExpr;
		private String newVarName;

		public DefineVar(String varType, String varName, String varExpr) {
			this.varType = varType;
			this.varName = varName;
			this.varExpr = varExpr;
			this.newVarName = null;
		}

		public void renameVarName(String newName) {
			this.newVarName = newName;
		}

		public String getNewVarName() {
			return this.newVarName;
		}

		public String toString() {
			if (newVarName == null)
				return varType + " " + varName + " = " + varExpr;
			else
				return varType + " " + varName + "(" + newVarName + ")" + " = "
						+ varExpr;
		}
	}

	public final ArrayList<DefineVar> defineVars;
	public final String code;

	public ActionSubConstruct(ArrayList<DefineVar> defineVars, String code) {
		this.code = code;
		this.defineVars = defineVars;
	}

	public void addDefineVar(DefineVar defineVar) {
		defineVars.add(defineVar);
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("@Action:\n");
		for (DefineVar defineVar : defineVars) {
			sb.append("\t@DefineVar: " + defineVar + "\n");
		}
		sb.append("\t@Code: " + code);
		return sb.toString();
	}
}
