package edu.uci.eecs.specCompiler.specExtraction;

public class ConditionalInterface {
	public final String interfaceName;
	public final String hbConditionLabel;
	
	public ConditionalInterface(String interfaceName, String hbConditionLabel) {
		this.interfaceName = interfaceName;
		this.hbConditionLabel = hbConditionLabel;
	}
	
	public boolean equals(ConditionalInterface other) {
		if (!(other instanceof ConditionalInterface))
			return false;
		ConditionalInterface another = (ConditionalInterface) other;
		return another.interfaceName.equals(interfaceName) && 
				another.hbConditionLabel.equals(hbConditionLabel);
	}
	
	public int hashCode() {
		return interfaceName.hashCode() << 5 ^ hbConditionLabel.hashCode();
	}
	
	public String toString() {
		if (hbConditionLabel.equals(""))
			return interfaceName + "(true)";
		else
			return interfaceName + "(" + hbConditionLabel + ")";
	}
}
